﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    public class AuthInfo
    {
        public string clientId { get; set; }
        public string clientSecret { get; set; }
        public string subscriptionId { get; set; }
        public string tenantId { get; set; }
        public string activeDirectoryEndpointUrl { get; set; }
        public string resourceManagerEndpointUrl { get; set; }
        public string activeDirectoryGraphResourceId { get; set; }
        public string sqlManagementEndpointUrl { get; set; }
        public string galleryEndpointUrl { get; set; }
        public string managementEndpointUrl { get; set; }
    }

    public class TokenInfo
    {
        public string token_type { get; set; }
        public string expires_in { get; set; }
        public string ext_expires_in { get; set; }
        public string expires_on { get; set; }
        public string not_before { get; set; }
        public string resource { get; set; }
        public string access_token { get; set; }
    }

    public class HardwareProfile
    {
        public string vmSize { get; set; }
    }

    public class ImageReference
    {
        public string publisher { get; set; }
        public string offer { get; set; }
        public string sku { get; set; }
        public string version { get; set; }
    }

    public class ManagedDisk
    {
        public string storageAccountType { get; set; }
        public string id { get; set; }
    }

    public class OsDisk
    {
        public string osType { get; set; }
        public string name { get; set; }
        public string createOption { get; set; }
        public string caching { get; set; }
        public ManagedDisk managedDisk { get; set; }
        public int diskSizeGB { get; set; }
    }

    public class StorageProfile
    {
        public ImageReference imageReference { get; set; }
        public OsDisk osDisk { get; set; }
        public List<object> dataDisks { get; set; }
    }

    public class WindowsConfiguration
    {
        public bool provisionVMAgent { get; set; }
        public bool enableAutomaticUpdates { get; set; }
    }

    public class OsProfile
    {
        public string computerName { get; set; }
        public string adminUsername { get; set; }
        public WindowsConfiguration windowsConfiguration { get; set; }
        public List<object> secrets { get; set; }
    }

    public class NetworkInterface
    {
        public string id { get; set; }
    }

    public class NetworkProfile
    {
        public List<NetworkInterface> networkInterfaces { get; set; }
    }

    public class Properties
    {
        public string vmId { get; set; }
        public HardwareProfile hardwareProfile { get; set; }
        public StorageProfile storageProfile { get; set; }
        public OsProfile osProfile { get; set; }
        public NetworkProfile networkProfile { get; set; }
        public string licenseType { get; set; }
        public string provisioningState { get; set; }
    }

    public class Tags
    {
    }

    public class Value
    {
        public Properties properties { get; set; }
        public string type { get; set; }
        public string location { get; set; }
        public Tags tags { get; set; }
        public string id { get; set; }
        public string name { get; set; }
    }

    public class VirtualMachineList
    {
        public List<Value> value { get; set; }
    }
}
